freeslot("SPR_CAPE", "S_SUPERMANCAPE", "MT_SUPERMANCAPE")

mobjinfo[MT_SUPERMANCAPE] = {
	spawnstate = S_SUPERMANCAPE,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_SUPERMANCAPE] = {
	sprite = SPR_CAPE,
	frame = A,
	tics = -1,
	nextstate = S_SUPERMANCAPE
}

addHook("MobjThinker", function(cape)
	if (cape.target.valid) and (cape.valid) and (cape.target.skin == "sonic") and (cape.target.player.powers[pw_super])
		local t = cape.target
		cape.scale = t.scale*2
		cape.momz = 0
		cape.momx = 0
		cape.momy = 0
		cape.angle = t.player.drawangle
		if (t.eflags & MFE_VERTICALFLIP)
			cape.eflags = $1|MFE_VERTICALFLIP
		elseif not (t.eflags & MFE_VERTICALFLIP)
			cape.eflags = $ & ~MFE_VERTICALFLIP
		end
		P_TeleportMove(cape, t.x+P_ReturnThrustX(cape, t.player.drawangle, -5*FRACUNIT), t.y+P_ReturnThrustY(cape, t.player.drawangle, -5*FRACUNIT), t.z+FixedMul(t.scale, 21*FRACUNIT))
	else
		if not (cape.target.valid)
			P_KillMobj(cape)
		else
			local t = cape.target
			t.player.hascape = false
			t.player.supercape = nil
			P_KillMobj(cape)
		end
	end
end, MT_SUPERMANCAPE)

addHook("MobjDeath", function(mo)
	for x=mo.x,mo.x+mo.radius*2,mo.radius*2
		for y=mo.y,mo.y+mo.radius*2,mo.radius*2
			local ss = R_PointInSubsector(x,y)
			for fof in ss.sector.ffloors()
				if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)	
                and (mo.z<=fof.topheight or mo.z+mo.height>=fof.bottomheight
                or (mo.eflags & MFE_VERTICALFLIP and (mo.z>=fof.bottomheight or mo.z-mo.height<=fof.topheight)))
					EV_CrumbleChain(ss.sector, fof)
				end
			end
		end
	end
end, MT_LASER)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sonic")
		if not (player.normalcolor)
			player.normalcolor = player.mo.color
		end
		if not (player.hascape)
			player.hascape = false
		end
		if not (player.capeflying)
			player.capeflying = false
		end
		if not (player.tossflaged)
			player.tossflaged = false
		end
		player.powers[pw_underwater] = 696969
		player.powers[pw_spacetime] = 696969
		if (player.capeflying == true)
			if (leveltime % 35 == 0) and (player.rings > 1)
				player.rings = $ - 1
			end
			player.pflags = $1|PF_THOKKED
			player.pflags = $1|PF_JUMPED
			player.mo.flags = $1|MF_NOGRAVITY
			if (player.cmd.buttons & BT_JUMP)
				P_SetObjectMomZ(player.mo, FRACUNIT, true)
				player.mo.state = S_PLAY_FLY
			elseif (player.cmd.buttons & BT_USE)
				player.mo.state = S_PLAY_FALL
				P_SetObjectMomZ(player.mo, -FRACUNIT, true)
			else
				player.mo.state = S_PLAY_FALL
				if (player.mo.momz > 0)
					player.mo.momz = $ - FRACUNIT
				elseif (player.mo.momz < 0)
					player.mo.momz = $ + FRACUNIT
				end
			end
		else
			player.mo.flags = $ & ~MF_NOGRAVITY
		end
		if (player.hascape == true) and not (player.supercape)
			player.supercape = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SUPERMANCAPE)
			player.supercape.target = player.mo
		elseif (player.hascape == false) and (player.supercape == true)
			player.supercape = nil
		end
		if (player.powers[pw_super])
			if (player.cmd.buttons & BT_CUSTOM1) and (player.rings > 0)
				if (leveltime % 5 == 0)
					player.rings = $ - 1
				end
				local laser = P_SpawnMobj(player.mo.x+P_ReturnThrustX(player.mo, player.mo.angle-ANG10, 5*FRACUNIT), player.mo.y+P_ReturnThrustY(player.mo, player.mo.angle-ANG10, 5*FRACUNIT), player.mo.z+8*FRACUNIT, MT_LASER)
				local laser2 = P_SpawnMobj(player.mo.x+P_ReturnThrustX(player.mo, player.mo.angle+ANG10, 5*FRACUNIT), player.mo.y+P_ReturnThrustY(player.mo, player.mo.angle+ANG10, 5*FRACUNIT), player.mo.z+8*FRACUNIT, MT_LASER)
				
				laser.target = player.mo
				laser.angle = player.mo.angle-ANG10
				laser.tics = 20*TICRATE
				laser.momz = FixedMul(player.speed+40*FRACUNIT, sin(player.aiming))	
				P_InstaThrust(laser, player.mo.angle-ANG10, player.speed+40*FRACUNIT)
				
				laser2.target = player.mo
				laser2.angle = player.mo.angle+ANG10
				laser2.tics = 20*TICRATE
				laser2.momz = FixedMul(player.speed+40*FRACUNIT, sin(player.aiming))	
				P_InstaThrust(laser2, player.mo.angle+ANG10, player.speed+40*FRACUNIT)
			end
			S_ChangeMusic("spman", true, player)
			player.mo.color = player.normalcolor
			player.hascape = true 
			local mo = player.mo
			for x=mo.x,mo.x+mo.radius+2*FRACUNIT,mo.radius+2*FRACUNIT
				for y=mo.y,mo.y+mo.radius+2*FRACUNIT,mo.radius+2*FRACUNIT
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
						and (mo.z==fof.topheight or mo.z+mo.height==fof.bottomheight
						or (mo.eflags & MFE_VERTICALFLIP and (mo.z==fof.bottomheight or mo.z-mo.height==fof.topheight)))
							EV_CrumbleChain(ss.sector, fof)
						end
					end
				end
			end
			if not P_IsObjectOnGround(player.mo)
			and (player.cmd.buttons & BT_TOSSFLAG)
			and (player.powers[pw_carry] == CR_NONE)
			and (player.tossflaged == false)
				if (player.capeflying == true)
					player.mo.state = S_PLAY_FALL
					player.capeflying = false
					player.charability = skins[player.mo.skin].ability
				else
					player.capeflying = true
					player.charability = CA_NONE
				end
				player.tossflaged = true
			elseif not (player.cmd.buttons & BT_TOSSFLAG)
			and (player.tossflaged == true)
				player.tossflaged = false
			end
		else
			player.normalcolor = player.mo.color
			player.hascape = false
			player.capeflying = false
		end
	elseif (player.mo.valid) and (player.mo.skin ~= "sonic")
		if (player.hascape)
			player.hascape = false
		end
		if (player.supercape)
			player.supercape = nil
		end
	end
end)

addHook("PlayerSpawn", function(player)
	player.supercape = nil
	player.hascape = false
	player.normalcolor = player.mo.color
end)

addHook("MobjMoveCollide", function(mobj, spike)
    if (mobj.player and mobj.skin == "sonic" and mobj.player.powers[pw_super] and mobj.state == S_PLAY_RUN)
	or (mobj.valid and mobj.type == MT_LASER)
		if (spike == nil) return end
		if (spike.valid and spike.type == MT_SPIKE)
			spike.health = 0
			S_StartSound(mobj, spike.info.deathsound)
			P_KillMobj(spike, mobj, mobj)
			return false
		end
	end
end)